'ReScroller 1.0
'Keeps the position on the page after a postback (only applicable to long pages)
'Example usage:
'<Bean:ReScroller id="rescroller" runat="server" />
' Written by Hunter Beanland
Imports System
Imports System.ComponentModel
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Microsoft.VisualBasic

Namespace Bean.Controls
    <ToolboxData("<{0}:ReScroller runat=server />")> Public Class ReScroller
        Inherits System.Web.UI.HtmlControls.HtmlInputHidden

        Private Const DOMBodyElement As String = "documentElement" 'XHTML=documentElement, HTML4=body ********************************************

        <Bindable(True), Category("Data"), DefaultValue("")> Property ScrollTop() As Integer
            Get
                If IsNothing(ViewState("ScrollTop")) Then ViewState("ScrollTop") = 0
                Return ViewState("ScrollTop")
            End Get

            Set(ByVal Value As Integer)
                ViewState("ScrollTop") = Value
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue("")> Property ScrollLeft() As Integer
            Get
                If IsNothing(ViewState("ScrollLeft")) Then ViewState("ScrollLeft") = 0
                Return ViewState("ScrollLeft")
            End Get

            Set(ByVal Value As Integer)
                ViewState("ScrollLeft") = Value
            End Set
        End Property

        Private Function LoadValues() As Boolean
            'Decode the postback values
            Dim aryValues() As String = Me.Value.Split(New Char() {","})
            If aryValues.Length = 2 Then
                If Not Integer.TryParse(aryValues(0), ScrollLeft) Then Return False
                If Not Integer.TryParse(aryValues(1), ScrollTop) Then Return False
            Else
                Return False
            End If
            Return True
        End Function

        Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
            'Build and register all the scripts
            Dim blnValidPosition As Boolean = LoadValues()
            Dim strScrollJS As String

            If Not Page.ClientScript.IsClientScriptBlockRegistered("start") Then
                strScrollJS = "<script type='text/javascript'>onscroll = function() {" & _
                 "document.getElementById('" & Me.ClientID & "').value = document." & DOMBodyElement & ".scrollLeft+','+document." & DOMBodyElement & ".scrollTop;" & _
                 "}</script>"
                Page.ClientScript.RegisterClientScriptBlock(Me.GetType, "onscroll", strScrollJS)
            End If

            If Not blnValidPosition Or (ScrollTop = 0 And ScrollLeft = 0) Then Exit Sub 'no point scrolling
            If Not Page.ClientScript.IsClientScriptBlockRegistered("scrollTo") Then
                strScrollJS = "<script type='text/javascript'>scrollTo(" & ScrollLeft.ToString & "," & ScrollTop.ToString & ");</script>"
                Page.ClientScript.RegisterStartupScript(Me.GetType, "scrollTo", strScrollJS)
            End If
        End Sub

    End Class
End Namespace
